---
type: api
title: Create an Elasticsearch project
description: Create an Elasticsearch project. The response will include the created project details, such as the project ID, the credentials to access the project, and the endpoints to access different apps such as Elasticsearch and Kibana. The credentials can be regenerated at any time using the _reset-credentials endpoint.
url: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/cloud-serverless/operation/operation-createelasticsearchproject
resource: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/cloud-serverless/operation/operation-createelasticsearchproject
products:
  - Elastic Cloud Serverless
---

# Create an Elasticsearch project

- Server: `https://api.elastic-cloud.com`

## Paths

- `POST` `/api/v1/serverless/projects/elasticsearch`

- [Api key auth](/elastic/docs-builder/docs/4371/api/doc/cloud-serverless/authentication#apikey)

## Description

Create an Elasticsearch project. The response will include the created project details, such as the project ID, the credentials to access the project, and the endpoints to access different apps such as Elasticsearch and Kibana. The credentials can be regenerated at any time using the _reset-credentials endpoint.

## Query String Parameters

- `exclude_credentials` (boolean)
  If true, the username and password fields in the response credentials are set to empty strings and no usable credentials are returned. Credentials can be retrieved later using the _reset-credentials endpoint.

## Request Body

`application/json`

Configuration of the elasticsearch project to create.

- `name` (string · min: 1 · max: 255) — required
  Descriptive name for a project.
- `alias` (string · min: 1 · max: 50 · pattern: ^[a-zA-Z]{1}(?:[a-zA-Z0-9-]*[a-zA-Z0-9]{1})?$) — optional
  A custom domain label compatible with RFC-1035 standards. Derived from the project name by default.
- `region_id` (string) — required
  Unique human-readable identifier for a region in Elastic Cloud.
- `optimized_for` (enum ElasticsearchOptimizedFor) — optional
  The purpose for which the hardware of this elasticsearch project is optimized. Also known as the Elasticsearch project subtype.

- The `general_purpose` option is suitable for most search use cases. For example, it is the right profile for full-text search, sparse vectors, and dense vectors that use compression such as BBQ. It is used by default when you create projects from the UI.
- The `vector` option is recommended only for uncompressed dense vectors (`dense_vector` fields with `int4` or `int8` quantization strategies) and high dimensionality. Refer to documentation about billing dimensions for the impact to virtual compute unit (VCU) consumption.
  Values: `general_purpose`, `vector`
- `search_lake` ({} ElasticsearchSearchLake) — optional
  Configuration for entire set of capabilities that make the data searchable in Elasticsearch.
  - `search_power` (integer · min: 28 · max: 3000) — optional
    Controls how fast searches are against your project data. When ingested, a certain amount of data is loaded into a cache that makes it super fast to query. You can either increase the performance of searches on cached data by adding replicas, or reduce the quantity of cached data by a static factor to save on costs.
  - `boost_window` (integer · min: 1 · max: 180) — optional
    Determines how much data can benefit from faster search. When ingested, a certain amount of data is loaded into a cache that makes it super fast to query. The system dynamically adjusts the cache allocated to your project based on how much data you ingest during the period defined by your Search Boost Window.
  - `min_search_vcu` (integer · min: 2 · max: 2500) — optional
    The minimum number of search VCUs allocated to your project.
- `traffic_filters` ([] TrafficFilters) — optional
  traffic filters IDs
  - `id` (string) — required
    traffic filter ID
- `linked` ({} CreateLinkedRequest) — optional
  Configuration for linked projects associated with this project
  - `projects` (map string to CreateLinkedProjectRequest) — required
    Map values ({} CreateLinkedProjectRequest)
    - `type` (enum ProjectType) — required
      The type of the linked project
      Values: `elasticsearch`, `observability`, `security`, `vectordb`
- `metadata` ({} ProjectMetadataRequest) — optional
  Metadata request for a project with tags.
  - `tags` (ProjectTags) — required
    Tags associated with a project in the form of key-value pairs. Tags are limited to a minimum of 1 and a maximum of 64 per project. Each tag key must begin with a lowercase letter (a-z), contain only lowercase letters, digits, underscores, and hyphens (a-z0-9_-), and have a maximum length of 32 characters.

## Responses

#### `201`

The created elasticsearch project.

`application/json`

- `id` (string · pattern: ^[a-z0-9]{32}$)
  ID of the project.
- `name` (string · min: 1 · max: 255)
  Descriptive name for a project.
- `alias` (string · min: 8 · max: 57 · pattern: ^[a-zA-Z]{1}(?:[a-zA-Z0-9-]*[a-zA-Z0-9]{1})?$)
  A domain label compatible with RFC-1035 standards. Project alias with a unique suffix added by the system to avoid naming conflicts.
- `region_id` (string)
  Unique human-readable identifier for a region in Elastic Cloud.
- `metadata` ({} ProjectMetadata)
  Additional details about the project.
  - `created_at` (string)
    Date and time when the project was created.
  - `created_by` (string)
    ID of the user.
  - `organization_id` (string)
    The Organization ID who owns the project.
  - `suspended_at` (string)
    Date and time when the project was suspended.
  - `suspended_reason` (string)
    Reason why the project was suspended.
  - `tags` (ProjectTags)
    Tags associated with a project in the form of key-value pairs. Tags are limited to a minimum of 1 and a maximum of 64 per project. Each tag key must begin with a lowercase letter (a-z), contain only lowercase letters, digits, underscores, and hyphens (a-z0-9_-), and have a maximum length of 32 characters.
  - `system_tags` (ProjectSystemTags)
    System tags associated with a project in the form of key-value pairs. These tags are added by the internal system and are read-only. The keys are prefixed with an underscore to differentiate them from user tags.
- `cloud_id` (string)
  The cloud ID, an encoded string that provides other Elastic services with the necessary information to connect to this Elasticsearch and Kibana.
- `traffic_filters` ([] TrafficFilters)
  traffic filters IDs
  - `id` (string)
    traffic filter ID
- `linked` ({} LinkConfiguration)
  Configuration for projects linked to this project
  - `projects` (map string to LinkedProject)
    Map values ({} LinkedProject)
    - `status` (enum LinkedProjectStatus)
      The state of the linked project.
      Values: `enabled`, `suspended`, `deleted`
    - `type` (enum ProjectType)
      The type of the linked project
      Values: `elasticsearch`, `observability`, `security`, `vectordb`
- `type` (enum)
  the type of the project
  Values: `elasticsearch`
- `optimized_for` (enum ElasticsearchOptimizedFor)
  The purpose for which the hardware of this elasticsearch project is optimized. Also known as the Elasticsearch project subtype.

- The `general_purpose` option is suitable for most search use cases. For example, it is the right profile for full-text search, sparse vectors, and dense vectors that use compression such as BBQ. It is used by default when you create projects from the UI.
- The `vector` option is recommended only for uncompressed dense vectors (`dense_vector` fields with `int4` or `int8` quantization strategies) and high dimensionality. Refer to documentation about billing dimensions for the impact to virtual compute unit (VCU) consumption.
  Values: `general_purpose`, `vector`
- `search_lake` ({} ElasticsearchSearchLake)
  Configuration for entire set of capabilities that make the data searchable in Elasticsearch.
  - `search_power` (integer · min: 28 · max: 3000)
    Controls how fast searches are against your project data. When ingested, a certain amount of data is loaded into a cache that makes it super fast to query. You can either increase the performance of searches on cached data by adding replicas, or reduce the quantity of cached data by a static factor to save on costs.
  - `boost_window` (integer · min: 1 · max: 180)
    Determines how much data can benefit from faster search. When ingested, a certain amount of data is loaded into a cache that makes it super fast to query. The system dynamically adjusts the cache allocated to your project based on how much data you ingest during the period defined by your Search Boost Window.
  - `min_search_vcu` (integer · min: 2 · max: 2500)
    The minimum number of search VCUs allocated to your project.
- `endpoints` ({} ElasticsearchProjectEndpoints)
  The endpoints to access the different apps of the project.
  - `elasticsearch` (string)
    The endpoint to access elasticsearch.
  - `kibana` (string)
    The endpoint to access kibana.
- `private_endpoints` ({} ElasticsearchProjectPrivateEndpoints)
  Private endpoints (URLs) for Elasticsearch projects when PrivateLink is enabled.
  - `elasticsearch` (string)
    The PrivateLink endpoint URL to access elasticsearch.
  - `kibana` (string)
    The PrivateLink endpoint URL to access kibana.
- `credentials` ({} ProjectCredentials)
  Basic auth credentials to access the Elasticsearch API.
  - `username` (string)
    Basic auth username that can be used to access the Elasticsearch API.
  - `password` (string)
    Basic auth password that can be used to access the Elasticsearch API.
##### Response Headers

- `ETag` (string)

#### `400`

Bad request

`application/json`

- `errors` ([] ErrorResponse)
  - `message` (string)
    A human-readable message of the error.
  - `code` (string)
    An identifier for this type of error.
#### `422`

Unprocessable entity

`application/json`

- `errors` ([] ErrorResponse)
  - `message` (string)
    A human-readable message of the error.
  - `code` (string)
    An identifier for this type of error.
## Code Examples

#### Console

```console
POST /api/v1/serverless/projects/elasticsearch
```

#### curl

```curl
curl -X POST "https://api.elastic-cloud.com/api/v1/serverless/projects/elasticsearch"
```

